#####################################################
# E-Blah Bulliten Board Systems  -  Platinum Series #
#####################################################
# Copyright (c) 2001 - 2006 E-Blah.                 #
#####################################################

{
	$usersetcount = 47; # Num. of user settings (current # is for a *NEW* value)
	$pwcry = 'ya'; # If 'ya' (below) is changed, change this also! This is conversion key!
	$pwlength = $encryption == 2 ? 20 : 8; # Max password length, 20 = MD5 encryption style; 8 = other

	$uflock = 1; # File Locking (Dis|En)abler
	$fopen  = 2;
	$fclose = 8;
}

sub fopen {
	my($fh,$fn) = @_;

	if($fn =~ m~/\.\./~) {
		eval { error("OPEN_ERROR",2); };
		die "\n\nYou MUST use absolute paths.\n\n";
	}

	if($debug >= 2) { ++$openedfiles; $openedfilenames .= "$fn ($fh)<br>"; }

	open($fh,$fn);
	if($uflock) {
		flock($fh,$fopen);
		seek($fh,0,0);
	} else { return(1); }
}

sub fclose {
	my($fh) = $_[0];
	if($uflock) { flock($fh,$fclose); }
	close($fh);
}

sub CheckCookies { # Find users cookies/SID
	foreach(split(/; /,$ENV{'HTTP_COOKIE'})) {
		$_ =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		($cname,$cval) = split(/=/);
		$Blah{$cname} = $cval;
	}

	if($Blah{"$cookpre\_pw"}) {
		$password = $Blah{"$cookpre\_pw"};
		$username = $Blah{"$cookpre\_un"};
	} else { AutoSid(); }
	if($username ne 'Guest') { GetUser(); }
	if($URL{'theme'}) { $usert .= "theme-$URL{'theme'}/"; }

	$scripturl = "$scriptname$modrewrite\lb-$URL{'b'}/$usert";
	$surl = "$scriptname$modrewrite$usert";
	$rurl = "$realurl$scriptname";
	if($modrewrite eq '?') { $rurl .= $modrewrite; }
}

sub AutoSid { # See if this is a running SID, find the user in the SID DB.
	my($sidip,$sidfnd,$sid,$tsid,$sidip,$sidun,$sidpw,$endtime,$baccess);
	if(!$ensids) { return; } # Disabled

	if($ENV{'REMOTE_ADDR'} eq '') { return; }
	$sidfnd = 0;
	fopen(SID,"$prefs/Sids.sid");
	while($sid = <SID>) {
		chomp $sid;
		($tsid,$sidip,$sidun,$sidpw,$endtime,$baccess) = split(/\|/,$sid);
		if(length($sidip) == length($ENV{'REMOTE_ADDR'}) && $ENV{'REMOTE_ADDR'} eq $sidip && $endtime > time) { $usert = "sid-$tsid/"; $sidfnd = 1; $sidinuse = 1; $endtime = 10800+(time); $username = $sidun; $password = $sidpw; } # Get SID in memory
		if($endtime > time) { $swrite .= "$tsid|$sidip|$sidun|$sidpw|$endtime|$baccess\n"; }
	}
	fclose(SID);

	fopen(SID,">$prefs/Sids.sid");
	print SID $swrite;
	fclose(SID);

	if(!$sidfnd) { $username = 'Guest'; $password = ''; } # Valid SID initiated
}

sub GetUser {
	my $count = -1;
	fopen(FILE,"$members/$username.dat") or $username = "Guest";
	while(<FILE>) {
		chomp;
		++$count;
		if($count == 0) {
			if($yabbconver) { $cryptpw = $_; } else { $cryptpw = Encrypt($_); }
			if($password ne $cryptpw) { $username = 'Guest'; $password = ''; @settings = (); return(); }
		}

		if($count == 23 && $_) { @settings = (); $settings[23] = $_; return(); }

		$pmdisable = 1 if($count == 38 && $_);
		@blockedusers = split(/\|/,$_) if($count == 40 && $_);
		$languagep = $_ if($count == 34 && $_ && -e("$languages/$_.lng"));

		push(@settings,$_);
		push(@Osettings,$_);
	}
	fclose(FILE);
}

sub Encrypt {
	if($yabbconver) {
		if($md5upgrade) { $encryption = $settings[46] ? 2 : 1; }
		if($encryption == 2) { # What method?
			require Digest::MD5;
			import Digest::MD5 qw(md5_hex);
			$crypted = md5_hex($_[0]);
		} else { $crypted = crypt($_[0],$pwcry); }
	} else { $crypted = $_[0]; }
	return($crypted);
}

sub GetThemes() {
	if($URL{'theme'}) { $settings[26] = $URL{'theme'}; }

	fopen(FILE,"$prefs/ThemesList.txt");
	@themes = <FILE>;
	fclose(FILE);
	chomp @themes;
	foreach(@themes) {
		($theme,$default,$timages,$tbuttons) = split(/\|/,$_);
		$theme{$theme,'images'} = $timages;
		$theme{$theme,'buttons'} = $tbuttons;
		$theme{$theme,'default'} = $default;
		if($default && $settings[26] eq '') { $dtheme = $theme; }
		if($theme eq $settings[26]) { $dtheme = $theme; }
		if($dtheme eq '') { $dtheme = $theme; }
	}

	$oimages = $images; $obuttons = $buttons;

	if($theme{$dtheme,'images'})  { $images = "$templatesu/$dtheme/images"; }
	if($theme{$dtheme,'buttons'}) { $buttons = "$templatesu/$dtheme/buttons"; }
}
1;